import java.util.ArrayList;
import pdftron.*;


public class test
{
	//chooses which example to run
	public static int example = 1;

	// You can modify the following lines with your registration information.
	static String username = "John Doe";
	static String company = "My Company";
	static String lic_key = "my license key";

	public static void main(String[] args)
	{
		PageMaster.init(username, company, lic_key);
		if (example == 1)
		{
			/// A simple PDF PageMaster program: Pass an explicit command-line string.
			///
			/// This example will split the file bookmark.pdf and create
			/// one new file for each page.
			///
			/// The -s parameter specifies that split is the operation
			/// The --digits parameter specifies that the numbers in resulting
			/// file names should have at least 2 digits
			/// The -o parameter specifies the output directory.  In this
			/// case that files should be created in the TestOutput/test1 directory
			
			//use the default callback
			PageMasterCallback cb = new PageMasterCallback();
			PageMaster.run("-s --digits 2 --verb 5 -o ../TestOutput/test1/ ../TestFiles/bookmark.pdf", cb, null);
		}
		else if (example == 2)
		{
			// An example of how to use PageMaster SDK to implement a command-line 
			// application for processing of PDF documents.
			String s = "";
			for (int i = 0; i < args.length; i++)
			{
				s += args[i] + " ";
			}

			PageMaster.run(s, new PageMasterCallback(), null);
		}
		else if (example == 3)
		{

			boolean linearized_output = true;
			boolean aes_encryption = false;
			String output_file = "../TestOutput/test3/test.pdf";
			String open_password = "mypass";
			String title = "My Title";
			String author = "Joe Doe";
			String subject = "My Subject";
			String keywords = "key1 key2 key2";
			String creator = "PDFTron PDFNet";
			String producer = "PageMaster";

			// Permissions
			boolean printing = false;
			boolean high_rez_printing = false;
			boolean doc_modifications = true;  // Changing the document
			boolean content_extraction = true;
			boolean commenting = true;
			boolean forms_editing = true;
			boolean accessibility = true;
			boolean document_assembly = true;

			// Given the above settings build a command string.
			String s = "";
			//specify the merge option
			s += "-m ";


			if (!(output_file == "")) s += "-o " + output_file + " ";

			if (!(open_password == "")) s += "--userpass " + open_password + " ";
			if (aes_encryption) s += "--AES ";


			// Set the permissions.
			s += "-e a -d \"";
			if (printing == false) s += "p";
			if (high_rez_printing == false) s += "h";
			if (doc_modifications == false) s += "m";
			if (content_extraction == false) s += "c";
			if (commenting == false) s += "o";
			if (forms_editing == false) s += "f";
			if (accessibility == false) s += "x";
			if (document_assembly == false) s += "s";
			s += "\" ";

			if (linearized_output) s += "-l ";

			// Set document information.
			if (!(title == "")) s += "--settitle \"" + title + "\" ";
			if (!(author == "")) s += "--setauthor \"" + author + "\" ";
			if (!(subject == "")) s += "--setsubject \"" + subject + "\" ";
			if (!(keywords == "")) s += "--setkeywords \"" + keywords + "\" ";
			if (!(creator == "")) s += "--setcreator \"" + creator + "\" ";
			if (!(producer == "")) s += "--setproducer \"" + producer + "\" ";

			// specify input files and folders...
			s += "../TestFiles/bookmark.pdf,1-15 ";
			s += "../TestFiles/secured.pdf|test ";
			s += "--verb 10";

			//an arraylist to store the saved file path(s)
			ArrayList saved_files = new ArrayList();

			// Execute the command string.
			PageMaster.run(s, new MyCallback(), saved_files);

			//print the saved file(s)
			System.out.println("The Saved File Is:");
			for (int i = 0; i < saved_files.size(); i++)
			{
				System.out.println(saved_files.get(i));
			}

			System.out.println("Done!!!");


		}


	}


}
//customized callback class
class MyCallback extends PageMasterCallback
{
	//OutFilename is called each time a file is saved
	//with the saved file path
	protected void OutFilename(String msg, Object user_data)
	{
		//store each file path in the saved_files arraylist
		if (msg != null && user_data != null)
			((ArrayList)user_data).add(msg);
	}

	//The following functions can also be changed

	//protected void Error(String msg, Object user_data) is called with
	//an error message when an error occurs
	
	//protected void Msg(String msg, Object user_data) is called with
	//any other messages
	
	//protected String GetPass(String msg, Object user_data) is called
	//when a password is needed for continued execution

}
